using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace WindowsApplication2
{
    public class DataObject : INotifyPropertyChanged
    {
        #region Fields
        private string id;
        private bool accept;
        private bool rollback;
        #endregion

        #region Properties
        public string Id
        {
            get { return id; }
            set { id = value; }
        }

        public bool Accept
        {
            get { return accept; }
            set
            {
                accept = value;
                Notify("Accept");

                // rollback and accept can't both be true. 
                // if accept is set to true and rollback is true, set rollback to false
                if (value && Rollback)
                {
                    Rollback = false;
                }
            }
        }

        public bool Rollback
        {
            get { return rollback; }
            set
            {
                rollback = value;
                Notify("Rollback");

                // rollback and accept can't both be true. 
                // if rollback is set to true and accept is true, set accept to false
                if (value && Accept)
                {
                    Accept = false;
                }
            }
        }
        #endregion

        #region Helpers
        private void Notify(string pName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(pName));
            }
        }
        #endregion

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}
